// -*- C++ -*-
/*!
 * @file  RTC_E1Motion_Manual.cpp
 * @brief E1制御用RTC　入力： ゲームコントローラ（別RTC）出力：制御コマンドstring　
 * @date $Date$
 *
 * @author AIZUK
 * kohno@aizuk.jp
 *
 * $Id$
 */

#include "RTC_E1Motion_Manual.h"

std::string COM_int_to_str(int data_num, int data);

//#define _PRINT_DEBUG
///////////////////////////////////
//PS4
//////////////////////////////////
int SQARE;
int OLD_SQARE;
int CROSS;
int CIRCLE;
int OLD_CIRCLE;
int TRIANGLE;
int OLD_TRIANGLE;
int L1;
int R1;
int L2;
int R2;
int SHARE;
int OLD_SHARE;
int OPTION;
int OLD_OPTION;
int L3;
int OLD_L3;
int R3;
int OLD_R3;
int PS;
int PS_CNT;
int PS_LP_Lock;
int OLD_PS;
int Touch;
int OLD_Touch;
float L2_A;
float R2_A;

int OLD_R2_UP;
int OLD_R2_DOWN;
int OLD_R2_LEFT;
int OLD_R2_RIGHT;
int OLD_R2_TRIANGLE;
int OLD_R2_CIRCLE;
int OLD_R2_CROSS;
int OLD_R2_SQARE;
int OLD_L2_L1;
int OLD_L2_R1;
int OLD_L2_CIRCLE;
//COMMON
float HAT_UP;
float HAT_DOWN;
float HAT_LEFT;
float HAT_RIGHT;
float LEFT_X;
float LEFT_Y;
float LEFT_X_;
float LEFT_Y_;
float RIGHT_X;
float RIGHT_Y;
//***************************************************************************//
int OLD_RIGHT_POS = 0;
int RIGHT_POS = 0;
int OLD_LEFT_POS = 0;
int OLD_LEFT_DC_FLG = 0;
int LEFT_DC_FLG = 0;
int LEFT_POS = 0;
int LEFT_FLG = 0;
int RIGHT_FLG = 0;
int LEFT_RIGHT_FLG = 0;
int OLD_LEFT_RIGHT_FLG = 0;
int p_button[20];//hex->2
int button[20];//hex->2
int A_FLG;//
int B_FLG;//
int MOVE_ARM=0;
int HAIDOBAN=0;
int R_ARM_FLG[10]={0,0,0,0,0,0,0,0,0,0};
int L_ARM_FLG[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
char com_E1[9][10];
int COM_VAL[40]{
	24584, 0, 65535, 00063, 0,
0, 0, 0, 2048, 2048,
2048, 2048, 2048, 2048, 0,
0, 100, 0, 0, 0,
0, 0, 0, 0, 0,
0, 0, 0, 0, 0,
2048, 2048, 2048, 2048, 2048,
2048, 2048, 2048, 20588 };//S_COM1から順にコマンド格納　アナログ値やCheckSum用
int COM_SUM = 0;//CheckSum用　割る前
int MODE[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int DEV_Tmp[10] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
int SENKAI_FLG = 0;
int Right_Arm_Move = 0;
int FB_Move = 0;
//***************************************************************************//
int DEV_NUM = 0;//0 ps4 1 E1 GUI
unsigned int scom3_pre[17] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
unsigned int scom4_pre[17] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };

//=================================================================================================================================================================//

//------------以下５桁---------------------------------------------------------------------------------------------------------------------------------------------//
std::string S_COM1("24584");		//運動可否　　24584の時通信中、24586の時運転可能状態
std::string S_COM2("00000");		//最下位数→0の時軸操作モード（０のみ推奨）　１軸づつでないと動かせない　他のモードもあるがまともではない	　
std::string S_CONT1("65535");		//部位使用可否判定１　14bitを10進数化した値  14bitALL1→16383
std::string S_CONT2("00063");		//部位使用可否判定２　14bitを10進数化した値　条件式等特になし電源オンなら１としていたらしい　10bitALL1→1023
std::string S_DA1("00000");			//使用せず	　　00000のみ

std::string S_DA2("00000");			//左ジョイスティック押しボタン　00000~00128
std::string S_DA3("00000");			//使用せず　	　00000のみ
std::string S_DA4("00000");			//右ジョイスティック押しボタン　00000~00128
std::string S_DA5("02048");			//左ピッチ回転　　00000~04095　02048の時に軸固定、これより大きくなると腕が下がり、小さくなると上がる
std::string S_DA6("02048");			//右ピッチ回転　　00000~04095　02048の時に軸固定、これより大きくなると腕が下がり、小さくなると上がる

std::string S_DA7("02048");			//左ヨー回転	　00000~04095　02048の時に軸固定、これより大きくなると右旋回、小さくなる左旋回
std::string S_DA8("02048");			//右ヨー回転	　00000~04095　02048の時に軸固定、これより大きくなると右旋回、小さくなる左旋回
std::string S_DA9("02048");			//使用せず　　　　02048で固定
std::string S_DA10("02048");		//使用せず		　02048で固定
std::string S_COM3("00000");		//デジタル出力　　14bitを10進数化した値　ものによっては確実にエラーを吐くものアリ　全機能は動かない

std::string S_COM4("00000");		//デジタル出力	　14bitを10進数化した値　ものによっては確実にエラーを吐くものアリ　全機能は動かない　（シフト等確認し難いものアリ）
//------------以下４桁---------------------------------------------------------------------------------------------------------------------------------------------//
std::string S_DA13("0100");			//使用せず	　　　0100で固定
std::string S_DA14("0000");			//使用せず	　　　0000のみ
std::string S_DA15("0000");			//使用せず	　　　0000のみ
std::string S_DA16("0000");			//使用せず	　　　0000のみ

std::string S_DA17("0000");			//使用せず	　　　0000のみ
std::string S_DA18("0000");			//使用せず	　　　0000のみ
std::string S_DA19("0000");			//使用せず	　　　0000のみ
std::string S_DA20("0000");			//使用せず	　　　0000のみ
std::string S_DA21("0000");			//使用せず	　　　0000のみ

std::string S_DA22("0000");			//使用せず	　　　0000のみ
std::string S_DA23("0000");			//使用せず	　　　0000のみ
std::string S_DA24("0000");			//使用せず	　　　0000のみ
std::string S_DA25("0000");			//使用せず	　　　0000のみ
std::string S_DA26("0000");			//使用せず	　　　0000のみ

std::string S_DA27("2048");			//ブレード	　　　0000~4095	2048の時に軸固定、大きくなると下降、小さくなると上昇。
std::string S_DA28("2048");			//クローラ　前後　0000~4095	2048の時に軸固定、大きくなると前進、小さくなると後退。
std::string S_DA29("2048");			//本体旋回	　	　0000~4095	2048の時に軸固定、大きくなると右旋回、小さくなると左旋回。
std::string S_DA30("2048");			//クローラ旋回	　0000~4095	2048の時に軸固定、大きくなると右旋回、小さくなると左旋回。
std::string S_DA31("2048");			//左手首回転	　0000~4095	2048の時に軸固定、大きくなると時計回り、小さくなると反時計回り。

std::string S_DA32("2048");			//左グリッパ	　0000~4095	2048の時に軸固定、大きくなるとグリッパを開き、小さくなると閉じる。
std::string S_DA33("2048");			//右手首回転	　0000~4095	2048の時に軸固定、大きくなると時計回り、小さくなると反時計回り。
std::string S_DA34("2048");			//右グリッパ	　0000~4095	2048の時に軸固定、大きくなるとグリッパを開き、小さくなると閉じる。
//------------以下５桁---------------------------------------------------------------------------------------------------------------------------------------------//
std::string CheckSum("");		//チェックサム	　すべての変数の値を足し、32768で割った時のあまりを表示
//-----------------------------------------------------------------------------------------------------------------------------------------------------------------//
std::string E1_COM;			//上記つなぎ合わせ　実際にE1に送るコマンド
//=================================================================================================================================================================//
// Module specification
// <rtc-template block="module_spec">
static const char* rtc_e1motion_manual_spec[] =
  {
    "implementation_id", "RTC_E1Motion_Manual",
    "type_name",         "RTC_E1Motion_Manual",
    "description",       "E1制御用RTC　入力： ゲームコントローラ（別RTC）出力：制御コマンドstring　",
    "version",           "1.0.0",
    "vendor",            "AIZUK",
    "category",          "Controller",
    "activity_type",     "PERIODIC",
    "kind",              "DataFlowComponent",
    "max_instance",      "1",
    "language",          "C++",
    "lang_type",         "compile",
    // Configuration variables
    "conf.default.Velocity_Gain", "1.0",
    // Widget
    "conf.__widget__.Velocity_Gain", "text",
    // Constraints
    ""
  };
// </rtc-template>

/*!
 * @brief constructor
 * @param manager Maneger Object
 */
RTC_E1Motion_Manual::RTC_E1Motion_Manual(RTC::Manager* manager)
    // <rtc-template block="initializer">
  : RTC::DataFlowComponentBase(manager),
    m_Controller_TypeIn("Controller_Type", m_Controller_Type),
    m_ButtonIn("Button", m_Button),
    m_AnalogIn("Analog", m_Analog),
    m_CommandOut("Command", m_Command)

    // </rtc-template>
{
}

/*!
 * @brief destructor
 */
RTC_E1Motion_Manual::~RTC_E1Motion_Manual()
{
}



RTC::ReturnCode_t RTC_E1Motion_Manual::onInitialize()
{
  // Registration: InPort/OutPort/Service
  // <rtc-template block="registration">
  // Set InPort buffers
  addInPort("Controller_Type", m_Controller_TypeIn);
  addInPort("Button", m_ButtonIn);
  addInPort("Analog", m_AnalogIn);
  
  // Set OutPort buffer
  addOutPort("Command", m_CommandOut);
  
  // Set service provider to Ports
  
  // Set service consumers to Ports
  
  // Set CORBA Service Ports
  
  // </rtc-template>

  // <rtc-template block="bind_config">
  // Bind variables and configuration variable
  bindParameter("Velocity_Gain", m_Velocity_Gain, "1.0");
  // </rtc-template>
m_Analog.data.length(11);

//system("chcp 20127");
system("chcp 65001");
//system("chcp 932");
//system("chcp 51932");
    return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onFinalize()
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onStartup(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onShutdown(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onActivated(RTC::UniqueId ec_id)
{   
	for(int i=0;i<11;i++){
        m_Analog.data[i]=0;
    }
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onDeactivated(RTC::UniqueId ec_id)
{
	DEV_NUM = 0;
	A_FLG = 0;
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onExecute(RTC::UniqueId ec_id)
{
  int i=0,thflg=0,quad=0;
 // double Stick_Jud[10];
  double Stick_Jud[10];
  double Vr,Vl,th;
  double wr,wl;
  double Vx,Vy,Va;
  char c[8];
  //std::string DEV_E1GUI = "E1_GUI";
  char  DEV_E1GUI[8] = "E1_GUI";
  system("cls");
  //Right_Arm_Move = 0;
  /***************************************************************************
  /
  /    　Button Read
  /
  ***************************************************************************/

  if (m_Controller_TypeIn.isNew()){
	  m_Controller_TypeIn.read();
	  //	std::wstring tex = m_String_IN.data;
	  std::cout << m_Controller_Type.data << std::endl;
	  if (strcmp(m_Controller_Type.data, DEV_E1GUI) == 0){
		  DEV_NUM = 1;
		  //printf("%d\n", DEV_NUM);
	  }
	  else{
		  DEV_NUM = 0;

	  }
  }

  printf(".\r\n");
/***************************************************************************
/	
/    　Button Read
/
***************************************************************************/
  if(m_ButtonIn.isNew()){
  	m_ButtonIn.read();
 
 	sprintf(c,"%04x",m_Button.data);
 	for(i=0;i<5;i++){
 		//std::cout<<"\x1b[1m" <<"\x1b[36m" 
 		//<< i<<"\t"<< c[i] << std::endl ;

	  	switch(c[i]){
		      case '1':  //0001
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case '2':  //0010
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case '3':  //0011
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case '4':  //0100
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case '5':  //0101
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case '6':  //0110
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case '7':  //0111
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case '8':  //1000
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=0;
		      break;
		      case '9':  //1001
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case 'A':  //1010
		      case 'a':  //1010
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case 'B':  //1011
		      case 'b':  //1011
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case 'C':  //1100
		      case 'c':  //1100
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case 'D':  //1101
		      case 'd':  //1101
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      case 'E':  //1110
		      case 'e':  //1110
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=0;
		      break;
		      
		      case 'F':  //1111
		      case 'f':  //1111
			      button[3+4*(- i + 3) ]=1;
			      button[2+4*(- i + 3) ]=1;
			      button[1+4*(- i + 3) ]=1;
			      button[4*(- i + 3) ]=1;
		      break;
		      
		      default://0000
			      button[3+4*(- i + 3) ]=0;
			      button[2+4*(- i + 3) ]=0;
			      button[1+4*(- i + 3) ]=0;
			      button[4*(- i + 3) ]=0;
		      break;
	  //num[i]= strtoul(ni_input, &e, 2);

		}
        }
	Button_Rename();
	B_FLG=1;
  }else{
  	for(i=0;i<20;i++){
  		button[i]=0;
  	}
	B_FLG=0;
  }//Button
	
/***************************************************************************
/	
/    　Analog Read
/
***************************************************************************/
  if(m_AnalogIn.isNew()){
	m_AnalogIn.read();
	Analog_Rename();
	A_FLG=1;
  }else{
  	A_FLG=0;
  }


///////////////////////////////////////////////
//
//使用せず・固定値
//	S_DA1 S_DA3 S_DA9 S_DA10 S_DA13～26 
///////////////////////////////////////////////
  COM_VAL[4] = 0;		//S_DA1
  COM_VAL[6] = 0;		//S_DA3

  COM_VAL[12] = 2048;	//S_DA9
  COM_VAL[13] = 2048;	//S_DA10

  COM_VAL[16] = 100;	//S_DA13
  COM_VAL[17] = 0;		//S_DA14
  COM_VAL[18] = 0;		//S_DA15
  COM_VAL[19] = 0;		//S_DA16
  COM_VAL[20] = 0;		//S_DA17
  COM_VAL[21] = 0;		//S_DA18
  COM_VAL[22] = 0;		//S_DA19
  COM_VAL[23] = 0;		//S_DA20
  COM_VAL[24] = 0;		//S_DA21
  COM_VAL[25] = 0;		//S_DA22
  COM_VAL[26] = 0;		//S_DA23
  COM_VAL[27] = 0;		//S_DA24
  COM_VAL[28] = 0;		//S_DA25
  COM_VAL[29] = 0;		//S_DA26
  

///////////////////////////////////////////////
//
//運転オンオフ
//	
///////////////////////////////////////////////
  if (PS){
	  if (OLD_PS == PS){
	  }
	  else{
		  if (MODE[0] == 1){
			  //運転オフ
			  MODE[0] = 0;
			  COM_VAL[0] = 24584;
		  }
		  else{
			  //運転オン
			  MODE[0] = 1;
			  COM_VAL[0] = 24586;
		  }

	  }
  }
  //printf("COM1%d\r\n", COM_VAL[0]);
  OLD_PS = PS;

  COM_VAL[0] = 24586;
///////////////////////////////////////////////
//
//操作モード
//	
///////////////////////////////////////////////
  COM_VAL[1] = 0;

///////////////////////////////////////////////
//
//部位使用判定　電源ONなら1rasii
//	
//  2/17のでは65535 63
///////////////////////////////////////////////
  COM_VAL[2] = 65535;// //14bit ALL116383; 16bitすべて1立てた後	14bitを変更？　１５，６bitには意味なし
  COM_VAL[3] = 63;////1023;  //10bit ALL1　


///////////////////////////////////////////////
//
//ジョイスティックボタン
//	
///////////////////////////////////////////////
  COM_VAL[5] = 0; //軸指定かんれん
  COM_VAL[7] = 0;  // 

///////////////////////////////////////////////
//
//アーム・動作切替
//	
///////////////////////////////////////////////

  //モード変更　走行　腕　カメラ
  if (Touch){
	  if (OLD_Touch == Touch){

	  }
	  else{
		  MOVE_ARM++;

		  if (MOVE_ARM>1)MOVE_ARM = 0;//     3段階変化

	  }
  }
  
  //printf("MOVEARM  %d\n", MOVE_ARM);
  OLD_Touch = Touch;
  /*
    if(Touch){
		if(OLD_Touch==Touch){

		}else{
			if(MOVE_ARM==1  ){
				MOVE_ARM=0;//      TYPE　- MOVE　
			}else{
				MOVE_ARM=1;//      TYPE　- ARM
			}
		}
	}
	OLD_Touch=Touch;
  */
///////////////////////////////////////////////
//
//アーム的な
//	　
///////////////////////////////////////////////
	LEFT_RIGHT_FLG =0;
	if (MOVE_ARM == 1 || DEV_NUM ==1 ){//アームモード時のみ HAT上下左右,○,×,△,□,L1,L2,L3,R1,R2,R3
		//動作部位決定_hidari
		LEFT_POS = 0;
		LEFT_FLG = 0;
		/////////////////////////////
		//第1関節
		/////////////////////////////
		if (HAT_RIGHT){
			L_ARM_FLG[0] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 1;
			}
		}
		else{
			L_ARM_FLG[0] = 0;
		}
		/////////////////////////////
		//第2関節
		/////////////////////////////

		if (HAT_DOWN){
			L_ARM_FLG[1] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 2;
			}
		}
		else{
			L_ARM_FLG[1] = 0;
		}
		/////////////////////////////
		//第3関節
		/////////////////////////////
		if (HAT_LEFT){
			L_ARM_FLG[2] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 3;
			}
		}
		else{
			L_ARM_FLG[2] = 0;
		}
		/////////////////////////////
		//第4関節
		/////////////////////////////
		if (HAT_UP){
			L_ARM_FLG[3] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 4;
			}

		}
		else{
			L_ARM_FLG[3] = 0;
		}
		/////////////////////////////
		//第5関節
		/////////////////////////////
		if (L1){
			L_ARM_FLG[4] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 5;
			}

		}
		else{
			L_ARM_FLG[4] = 0;
		}
		/////////////////////////////
		//第6関節
		/////////////////////////////
		if (L2){
			L_ARM_FLG[5] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 6;
			}

		}
		else{
			L_ARM_FLG[5] = 0;
		}
		/////////////////////////////
		//第7関節
		/////////////////////////////
		if (R3){
			L_ARM_FLG[6] = 1;
			if (OLD_LEFT_POS == LEFT_POS){
				LEFT_POS = 7;
			}
		}
		else{
			L_ARM_FLG[6] = 0;
		}


		if (L_ARM_FLG[0] == 1 && OLD_LEFT_POS == 1){
			LEFT_POS = 1;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[1] == 1 && OLD_LEFT_POS == 2){
			LEFT_POS = 2;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[2] == 1 && OLD_LEFT_POS == 3){
			LEFT_POS = 3;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[3] == 1 && OLD_LEFT_POS == 4){
			LEFT_POS = 4;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[4] == 1 && OLD_LEFT_POS == 5){
			LEFT_POS = 5;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[5] == 1 && OLD_LEFT_POS == 6){
			LEFT_POS = 6;
			LEFT_FLG = 1;
		}
		if (L_ARM_FLG[6] == 1 && OLD_LEFT_POS == 7){
			LEFT_POS = 7;
			LEFT_FLG = 1;
		}
		//printf("PS:%d	OLD:%d\n", LEFT_POS, OLD_LEFT_POS);
		OLD_LEFT_POS = LEFT_POS;




		//動作部位決定migi
		RIGHT_POS = 0;
		RIGHT_FLG = 0;
		/////////////////////////////
		//第1関節
		/////////////////////////////
		if (SQARE){
			R_ARM_FLG[0] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 1;
			}
		}
		else{
			R_ARM_FLG[0] = 0;
		}
		/////////////////////////////
		//第2関節
		/////////////////////////////
		if (CROSS){
			R_ARM_FLG[1] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 2;
			}
		}
		else{
			R_ARM_FLG[1] = 0;

		}
		/////////////////////////////
		//第3関節
		/////////////////////////////
		if (CIRCLE){
			R_ARM_FLG[2] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 3;
			}
		}
		else{
			R_ARM_FLG[2] = 0;
		}
		/////////////////////////////
		//第4関節
		/////////////////////////////
		if (TRIANGLE){
			R_ARM_FLG[3] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 4;
			}
		}
		else{
			R_ARM_FLG[3] = 0;
		}
		/////////////////////////////
		//第5関節
		/////////////////////////////
		if (R1){
			R_ARM_FLG[4] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 5;
			}
		}
		else{
			R_ARM_FLG[4] = 0;

		}
		/////////////////////////////
		//第6関節
		/////////////////////////////
		if (R2){
			R_ARM_FLG[5] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 6;
			}
		}
		else{
			R_ARM_FLG[5] = 0;
		}
		/////////////////////////////
		//第7関節
		/////////////////////////////
		if (L3){
			R_ARM_FLG[6] = 1;
			if (OLD_RIGHT_POS == RIGHT_POS){
				RIGHT_POS = 7;
			}
		}
		else{
			R_ARM_FLG[6] = 0;
		}


		if (R_ARM_FLG[0] == 1 && OLD_RIGHT_POS == 1){
			RIGHT_POS = 1;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[1] == 1 && OLD_RIGHT_POS == 2){
			RIGHT_POS = 2;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[2] == 1 && OLD_RIGHT_POS == 3){
			RIGHT_POS = 3;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[3] == 1 && OLD_RIGHT_POS == 4){
			RIGHT_POS = 4;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[4] == 1 && OLD_RIGHT_POS == 5){
			RIGHT_POS = 5;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[5] == 1 && OLD_RIGHT_POS == 6){
			RIGHT_POS = 6;
			RIGHT_FLG = 1;
		}
		if (R_ARM_FLG[6] == 1 && OLD_RIGHT_POS == 7){
			RIGHT_POS = 7;
			RIGHT_FLG = 1;
		}



		if (LEFT_FLG == 1 && RIGHT_FLG == 0){
			LEFT_RIGHT_FLG = 1;
		}
		else if (LEFT_FLG == 0 && RIGHT_FLG == 1){
			LEFT_RIGHT_FLG = 2;
		}
		else if (LEFT_FLG == 1 && RIGHT_FLG == 1){
			if (OLD_LEFT_RIGHT_FLG == 1)LEFT_RIGHT_FLG = 1;
			if (OLD_LEFT_RIGHT_FLG == 2)LEFT_RIGHT_FLG = 2;
		}
		else{
			LEFT_RIGHT_FLG = 0;
		}

		if (LEFT_RIGHT_FLG == 1){
			COM_VAL[5] = 0000;//S_DA2 どの部位動くか
			COM_VAL[7] = 0000;//0? S_DA4
			printf("==============LEFT_ARM==%d============\n", LEFT_POS);
		}
		if (LEFT_RIGHT_FLG == 2){
			COM_VAL[5] = 0000;//0? S_DA2
			COM_VAL[7] = 0000;// S_DA4　どの部位動くか
			printf("==============RIGHT_ARM=%d=============\n", RIGHT_POS);
	
		}

		//printf("PS:%d	OLD:%d\n", RIGHT_POS, OLD_RIGHT_POS);
		OLD_RIGHT_POS = RIGHT_POS;
		OLD_LEFT_RIGHT_FLG = LEFT_RIGHT_FLG;


}
///////////////////////////////////////////////
//
//各種機能
//	
///////////////////////////////////////////////

COM_VAL[14] = 0;
COM_VAL[15] = 24;
//機能
//int scom3_ = 0x00;
//unsigned char scom3_pre[17] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 }
unsigned int scom3_ = 0x00;
//unsigned int scom4_pre[17] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
unsigned int scom4_ = 0x00;
scom4_ = 24;
if (MOVE_ARM == 0 || MOVE_ARM == 1 || MOVE_ARM == 2 || DEV_NUM == 1){ //走行とアーム時
	if (R2){
		/*
		if(Touch){
		if(OLD_Touch==Touch){

		}else{
		if(MOVE_ARM==1  ){
		MOVE_ARM=0;//      TYPE　- MOVE　
		}else{
		MOVE_ARM=1;//      TYPE　- ARM
		}
		}
		}
		OLD_Touch=Touch;
		*/
		if (HAT_UP){
			if (OLD_R2_UP == HAT_UP){
			}else{
				if (scom3_pre[0] == 0x100){
					scom3_pre[0] = 0x00;
				}
				else{
					scom3_pre[0] = 0x100;
				}
			}
			//頭照明 8bit
			//printf("SOCOM3_1\r\n");
		}
		OLD_R2_UP = HAT_UP;
		if (scom3_pre[0] == 0x100)printf("Head Light \r\n");

		if (HAT_LEFT){
			//左腕照明　9bit
			if (OLD_R2_LEFT == HAT_LEFT){
			}
			else{
				if (scom3_pre[1] == 0x200){
					scom3_pre[1] = 0x00;
				}
				else{
					scom3_pre[1] = 0x200;
				}
			}
			//頭照明 8bit
			//printf("SOCOM3_1\r\n");
//			scom3_pre[1] = 0x100;
			//printf("SOCOM3_1\r\n");

		}
		OLD_R2_LEFT = HAT_LEFT;
		if (scom3_pre[1] == 0x200)printf("Left Arm Light \r\n");
		if (HAT_RIGHT){
			///右腕照明 10bit
			if (OLD_R2_RIGHT == HAT_RIGHT){
			}
			else{
				if (scom3_pre[2] == 0x400){
					scom3_pre[2] = 0x00;
				}
				else{
					scom3_pre[2] = 0x400;
				}
			}
	//		scom3_pre[2] = 0x200;

			//printf("SOCOM3_3\r\n");
			//printf("SOCOM3 =%x\r\n", scom3_pre[3]);
		}
		OLD_R2_RIGHT = HAT_RIGHT;
		if (scom3_pre[2] == 0x400)printf("Right Arm Light \r\n");

	

		if (TRIANGLE){
			///前面照明 11bit
			if (OLD_R2_TRIANGLE == TRIANGLE){
			}
			else{
				if (scom3_pre[3] == 0x800){
					scom3_pre[3] = 0x00;
				}
				else{
					scom3_pre[3] = 0x800;
				}
			}
		//	scom3_pre[3] = 0x400;
		}
		OLD_R2_TRIANGLE = TRIANGLE;
		if (scom3_pre[3] == 0x800)printf("Front Light \r\n");
		if (CROSS){
			///後面照明 12bit
			if (OLD_R2_CROSS == CROSS){
			}
			else{
				if (scom3_pre[4] == 0x1000){
					scom3_pre[4] = 0x00;
				}
				else{
					scom3_pre[4] = 0x1000;
				}
			}
			//scom3_pre[4] = 0x800;

		}
		OLD_R2_CROSS = CROSS;
		if (scom3_pre[4] == 0x1000)printf("Rear Light \r\n");


		if (SQARE){
			///左側面照明 13bit
			if (OLD_R2_SQARE == SQARE){
			}
			else{
				if (scom3_pre[5] == 0x2000){
					scom3_pre[5] = 0x00;
				}
				else{
					scom3_pre[5] = 0x2000;
				}
			}
			//scom3_pre[5] = 0x1000;
		}
		OLD_R2_SQARE = SQARE;

		if (scom3_pre[5] == 0x2000)printf("Left Side Light \r\n");
		if (CIRCLE){
			///右側面照明 14bit
			if (OLD_R2_CIRCLE == CIRCLE){
			}
			else{
				if (scom3_pre[6] == 0x4000){
					scom3_pre[6] = 0x00;
				}
				else{
					scom3_pre[6] = 0x4000;
				}
			}
			//scom3_pre[6] = 0x2000;
		}
		OLD_R2_CIRCLE = CIRCLE;
		if (scom3_pre[6] == 0x4000)printf("Righ Side Light\r\n");

		if (HAT_DOWN){	///ホーン 1bit

			scom3_pre[7] = 0x01;
		}
		else{
			scom3_pre[7] = 0x00;

		}
		if (scom3_pre[7] == 0x01)printf("Horn \r\n");


	}



	else if (L2){
		
			if (L1){
				//左指示器 6bit
				if (OLD_L2_L1 == L1){
				}
				else{
					if (scom4_pre[5] == 0x20){
						scom4_pre[5] = 0x00;
					}
					else{
						scom4_pre[5] = 0x20;
					}
				}
//				scom4_pre[5] = 0x20;
			}
			OLD_L2_L1 = L1;
			if (scom4_pre[5] == 0x20)printf("Left-Turn Signal \r\n");
			if (R1){
				//右指示器 7bit
				if (OLD_L2_R1 == R1){
				}
				else{
					if (scom4_pre[6] == 0x40){
						scom4_pre[6] = 0x00;
					}
					else{
						scom4_pre[6] = 0x40;
					}
				}
				//scom4_pre[6] = 0x40;
			}
			OLD_L2_R1 = R1;
			if (scom4_pre[6] == 0x40)printf("Right-Turn Signal \r\n");

			if (TRIANGLE){
				//アクセルアップ 1bit
				scom4_pre[1] = 0x01;
				printf("Accelerator Up \r\n");
			}
			else{
				scom4_pre[1] = 0x00;
			}
			
			if (CROSS){
				//アクセルダウン 2bit
				scom4_pre[0] = 0x02;
				printf("Accelerator Down \r\n");

			}
			else{
				scom4_pre[0] = 0x00;
			}

			if (SQARE){
				//soukoukirikae 3bit
				scom4_pre[2] = 0x04;
				printf("Drive-Change \r\n");
			}
			else{
				scom4_pre[2] = 0x00;
			}

			if (CIRCLE){
				//ハザード 8bit
				if (OLD_L2_CIRCLE == CIRCLE){
				}
				else{
					if (scom4_pre[3] == 0x80){
						scom4_pre[3] = 0x00;
					}
					else{
						scom4_pre[3] = 0x80;
					}
				}
				//scom4_pre[3] = 0x80;
			}
			OLD_L2_CIRCLE = CIRCLE;
			if (scom4_pre[3] == 0x40)printf("Hazard Lights \r\n");
		}


	//腕　4bit 5bit
	scom4_pre[4] = 0x18;

	scom3_ = scom3_pre[0] | scom3_pre[1];
	scom3_ |= scom3_pre[2];
	scom3_ |= scom3_pre[3];
	scom3_ |= scom3_pre[4];
	scom3_ |= scom3_pre[5];
	scom3_ |= scom3_pre[6];
	scom3_ |= scom3_pre[7];

	COM_VAL[14] = scom3_;
	//	printf("SOCOM3 =%x\r\n", scom3_);
		scom3_ |= scom3_pre[7];
	//	printf("SOCOM3 =%x\r\n", scom3_);

	scom4_ = scom4_pre[0] | scom4_pre[1];
	scom4_ |= scom4_pre[2];
	scom4_ |= scom4_pre[3];
	scom4_ |= scom4_pre[4];
	scom4_ |= scom4_pre[5];
	scom4_ |= scom4_pre[6];
	COM_VAL[15] = scom4_;
	//	printf("SOCOM4 =%x\r\n", scom4_);

}
///////////////////////////////////////////////
//
//HAIDOBAN的な
//	どのモードでも
///////////////////////////////////////////////
if(OPTION){//排土板UP
	printf("BLADE Down \r\n");
	HAIDOBAN=1;
	COM_VAL[30] = 4095;//排土板上昇　５０％くらいか　速度不明
}
else if (SHARE){//排土板DOWN
	printf("BLADE Up \r\n");
	HAIDOBAN = -1;
	COM_VAL[30] = 0;//1024;//排土板DOWN　５０％くらいか

}else{
	HAIDOBAN=0;
	COM_VAL[30] = 2048;//排土板停止
}

///////////////////////////////////////////////
//
//速度的な
//	
///////////////////////////////////////////////
if (MOVE_ARM == 0 || DEV_NUM == 1){//走行モード時
	//腕関連停止

	COM_VAL[5] = 0;//0? S_DA2 どの部位動くか
	COM_VAL[7] = 0;//0? S_DA4

	COM_VAL[8]  = 2048;//
	COM_VAL[9]  = 2048;//
	COM_VAL[10] = 2048;//
	COM_VAL[11] = 2048;//
	COM_VAL[34] = 2048;//
	COM_VAL[35] = 2048;//
	COM_VAL[36] = 2048;//
	COM_VAL[37] = 2048;//

	printf("=============================\r\n");
	printf("          走行モード　　　　\r\n");
	printf("=============================\r\n");



	COM_VAL[31] = (-1 * LEFT_X + 1) * 2048;
	if (COM_VAL[31] > 4095)COM_VAL[31] = 4095;
	if (COM_VAL[31]<0)COM_VAL[31] = 0;
	COM_VAL[33] = (LEFT_Y + 1) * 2048;
	//printf("旋回 \r\n");
	if (COM_VAL[33]>4095)COM_VAL[33] = 4095;
	if (COM_VAL[33]<0)COM_VAL[33] = 0;
//	printf("SOCOM =%x\r\n", scom4_);
	/*

	//スティック前後進旋回　機体旋回
	if (LEFT_Y > -0.5 && LEFT_Y < 0.5&& LEFT_X != 0){//前進
		FB_Move++;
		if (FB_Move > 2){
			COM_VAL[31] = (-1 * LEFT_X + 1) * 2048;
			if (COM_VAL[31] > 4095)COM_VAL[31] = 4095;
			if (COM_VAL[31]<0)COM_VAL[31] = 0;
			//printf("FR=LEFT_X %d\r\n", COM_VAL[31]);
			COM_VAL[33] = 2048;//前進中旋回は不可
			COM_VAL[32] = 2048;//前進中本体旋回は不可
		}
	}else{
		COM_VAL[31] = 2048;
		FB_Move = 0;
	}

	if (LEFT_X > -0.5 && LEFT_X < 0.5 && LEFT_Y != 0){//旋回
		COM_VAL[33] = (LEFT_Y + 1) * 2048;
		//printf("旋回 \r\n");
		if (COM_VAL[33]>4095)COM_VAL[33] = 4095;
		if (COM_VAL[33]<0)COM_VAL[33] = 0;

		//if (COM_VAL[33]>2048) printf("Right-Turn \r\n");
		// if (COM_VAL[33] < 2048) printf("Left-Turn \r\n");

		COM_VAL[31] = 2048;//旋回中前進は不可
		COM_VAL[32] = 2048;//旋回中本体旋回は不可
		
		//printf("LR=LEFT_Y %d\r\n", COM_VAL[33]);
	}
	else{
		COM_VAL[33] = 2048;
	}*/

	if (RIGHT_X > -0.5 && RIGHT_X < 0.5 &&  RIGHT_Y != 0){//本体旋回
		
		COM_VAL[32] = (RIGHT_Y + 1) * 2048;
		if (COM_VAL[32]>4095)COM_VAL[32] = 4095;
		if (COM_VAL[32]<0)COM_VAL[32] = 0;
		//printf("BODY=RIGHT_Y %d\r\n", COM_VAL[32] );
		COM_VAL[31] = 2048;//本体旋回中前進は不可
		COM_VAL[33] = 2048;//本体旋回中旋回は不可
		SENKAI_FLG = 1;
		COM_VAL[5] = 128;
	}
	else{
		COM_VAL[32] = 2048;
		SENKAI_FLG = 0;
		COM_VAL[5] = 0;
	}
	DEV_Tmp[0] = COM_VAL[31];
	DEV_Tmp[1] = COM_VAL[32];
	DEV_Tmp[2] = COM_VAL[33];
	if (COM_VAL[5]==128)	DEV_Tmp[3] = COM_VAL[5];
	else DEV_Tmp[3] = 0;


}
///////////////////////////////////////////////
//
//アームモード時な
//	ろーる　よー　の選択は選択部位による
///////////////////////////////////////////////
 if (MOVE_ARM == 1 || DEV_NUM == 1){//アームモード時
	COM_VAL[31] = 2048;
	COM_VAL[32] = 2048;
	COM_VAL[33] = 2048;
	printf("=============================\r\n");
	printf("         アームモード　　　　\r\n");
	printf("=============================\r\n");

	if (LEFT_RIGHT_FLG == 1){
		//右全停止
		COM_VAL[7] = 0;//SDA4右担当
		COM_VAL[9] = 2048;
		COM_VAL[11] = 2048;
		COM_VAL[36] = 2048;
		COM_VAL[37] = 2048;

		int Lstickpre = (-1 * RIGHT_X + 1) * 2048;
		if (Lstickpre>4095)Lstickpre = 4095;
		if (Lstickpre<0)Lstickpre = 0;

		if (LEFT_POS == 1){//左第１ヨー

			COM_VAL[5] = 4;//SDA2左担当　SW-A
			COM_VAL[8] = 2048;//Lstickpre;
			COM_VAL[10] = Lstickpre;
			COM_VAL[34] = 2048;//手首動作不可
			COM_VAL[35] = 2048;//グリッパ動作不可
			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 2){//左第２　ピッチ
			COM_VAL[5] = 4;//SDA2左担当　SW-A
			COM_VAL[8] = (Lstickpre-4095)*-1;
			COM_VAL[10] = 2048;// Lstickpre;
			COM_VAL[34] = 2048;//手首動作不可
			COM_VAL[35] = 2048;//グリッパ動作不可
			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 3){//左第３　ピッチ
			COM_VAL[5] = 16;//SDA2左担当　SW-B
			COM_VAL[8] = (Lstickpre - 4095)*-1;
			COM_VAL[10] = 2048;// Lstickpre;
			COM_VAL[34] = 2048;//手首動作不可
			COM_VAL[35] = 2048;//グリッパ動作不可
		//	printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 4){//左第４　ピッチ
			COM_VAL[5] = 0;//SDA2左担当
			COM_VAL[8] = (Lstickpre - 4095)*-1;
			COM_VAL[10] = 2048; //Lstickpre;
			COM_VAL[34] = 2048;//手首動作不可
			COM_VAL[35] = 2048;//グリッパ動作不可
			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 5){//左第５　ヨー
			COM_VAL[5] = 0;//SDA2左担当　
			COM_VAL[8] = 2048;//Lstickpre;
			COM_VAL[10] = Lstickpre;
			COM_VAL[34] = 2048;//手首動作不可
			COM_VAL[35] = 2048;//グリッパ動作不可

			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 6){//左手首
			////////////////////////////////////////////////////////////////////////////========================================================================-
			COM_VAL[5] = 0;//SDA2左担当　正面ロッカ　
			COM_VAL[8] = 2048;//Lstickpre;
			COM_VAL[10] = 2048;
			COM_VAL[34] = Lstickpre;
			COM_VAL[35] = 2048;//グリッパ動作不可
			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else if (LEFT_POS == 7){//左グリッパ
			COM_VAL[5] = 0;//SDA2左担当　背面ロッカ
			COM_VAL[8] = 2048;//Lstickpre;
			COM_VAL[10] = 2048;
			COM_VAL[34] = 2048;
			COM_VAL[35] = Lstickpre;
			//printf("FR=LEFT_X %d\r\n", COM_VAL[34]);
		}
		else{
			COM_VAL[5] = 0;//SDA2左担当　背面ロッカ
			COM_VAL[8] = 2048;//Lstickpre;
			COM_VAL[10] = 2048;
			COM_VAL[34] = 2048;
			COM_VAL[35] = 2048;

		}
	}



	else if (LEFT_RIGHT_FLG == 2){//右のみ
		//左全停止
		COM_VAL[5] = 0;//SDA2左担当　SW-A
		COM_VAL[8] = 2048;//Lstickpre;
		COM_VAL[10] = 2048;
		COM_VAL[34] = 2048;//手首動作不可
		COM_VAL[35] = 2048;//グリッパ動作不可
	

		int Rstickpre = (-1 * LEFT_X + 1) * 2048;
		if (Rstickpre>4095)Rstickpre = 4095;
		if (Rstickpre<0)Rstickpre = 0;

		if (RIGHT_POS == 1){//右第１　ヨー

			COM_VAL[7] = 4;//SDA2右担当　SW-A
			COM_VAL[9] = 2048;
			COM_VAL[11] = Rstickpre;
			COM_VAL[36] = 2048;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 2){//右第２　ピッチ
			COM_VAL[7] = 4;//SDA2右担当　SW-A
			COM_VAL[9] = (Rstickpre-4095)*-1;
			COM_VAL[11] = 2048;
			COM_VAL[36] = 2048;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 3){//右第３　ピッチ
			COM_VAL[7] = 16;//SDA2右担当　SW-B
			COM_VAL[9] = (Rstickpre - 4095)*-1;
			COM_VAL[11] = 2048;
			COM_VAL[36] = 2048;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 4){//右第４　ピッチ
			COM_VAL[7] = 0;//SDA2右担当　
			COM_VAL[9] = (Rstickpre - 4095)*-1;
			COM_VAL[11] = 2048;
			COM_VAL[36] = 2048;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 5){//右第５　ヨー
			COM_VAL[7] = 0;//SDA2右担当　
			COM_VAL[9] = 2048;
			COM_VAL[11] = Rstickpre;
			COM_VAL[36] = 2048;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 6){//右手首
			COM_VAL[7] = 0;//SDA2右担当　
			COM_VAL[9] = 2048;
			COM_VAL[11] = 2048;

			COM_VAL[36] = Rstickpre;
			COM_VAL[37] = 2048;
			Right_Arm_Move = 1;
		}
		else if (RIGHT_POS == 7){//右グリッパ
			COM_VAL[7] = 0;//SDA2右担当　
			COM_VAL[9] = 2048;
			COM_VAL[11] = 2048;
			COM_VAL[36] = 2048;

			COM_VAL[37] = Rstickpre;
			Right_Arm_Move = 1;
		}
		else{
			COM_VAL[7] = 0;//SDA2右担当　
			COM_VAL[9] = 2048;
			COM_VAL[11] = 2048;
			COM_VAL[36] = 2048;

			COM_VAL[37] = 2048;

		}

	}
	else{
		COM_VAL[5] = 0;//SDA2左担当　背面ロッカ
		COM_VAL[8] = 2048;//Lstickpre;
		COM_VAL[10] = 2048;
		COM_VAL[34] = 2048;
		COM_VAL[35] = 2048;


		COM_VAL[7] = 0;//SDA2右担当　
		COM_VAL[9] = 2048;
		COM_VAL[11] = 2048;
		COM_VAL[36] = 2048;
		COM_VAL[37] = 2048;
		Right_Arm_Move = 0;
	}
		
		
		
} 
/*
if (MOVE_ARM == 2){//カメラモード時
//全動作停止
	//動作停止
	COM_VAL[30] = 2048;
	COM_VAL[31] = 2048;
	COM_VAL[32] = 2048;
	COM_VAL[33] = 2048;
	//腕停止
	COM_VAL[5] = 0;//SDA2左担当　背面ロッカ
	COM_VAL[8] = 2048;//Lstickpre;
	COM_VAL[10] = 2048;
	COM_VAL[34] = 2048;
	COM_VAL[35] = 2048;
	
	COM_VAL[7] = 0;//SDA2右担当　
	COM_VAL[9] = 2048;
	COM_VAL[11] = 2048;
	COM_VAL[36] = 2048;
	COM_VAL[37] = 2048;
	printf("=============================\r\n");
	printf("         カメラモード　　　　\r\n");
	printf("=============================\r\n");
	unsigned int scom3_cam_pre[17] = { 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0 };
	int scom3_cam_ = 0x00000;

	if (HAT_UP){
		//カメラ上移動 ２bit
		printf("カメラ上移動 \r\n");
		scom3_cam_pre[0] = 0x02;

		//printf("SOCOM3_1\r\n");

	}
	if (HAT_LEFT){
		//カメラ左移動　４bit
		printf("カメラ左移動 \r\n");
		scom3_cam_pre[1] = 0x08;
		//printf("SOCOM3_1\r\n");

	}
	if (HAT_RIGHT){
		///カメラ右移動 ５bit
		printf("カメラ右移動 \r\n");
		scom3_cam_pre[2] = 0x10;

		//printf("SOCOM3_3\r\n");
		//printf("SOCOM3 =%x\r\n", scom3_pre[3]);
	}
	if (HAT_DOWN){
		///カメ2下移動 ３bit
		printf("カメラ下移動 \r\n");
		scom3_cam_pre[3] = 0x04;
	}
	if (SQARE){
		///カメラズーム左 ６bit
		printf("カメラズーム左 \r\n");
		scom3_cam_pre[4] = 0x20;
	}
	if (CIRCLE){
		///カメラズーム右 7bit
		printf("カメラズーム右 \r\n");
		scom3_cam_pre[5] = 0x40;

	}

	scom3_cam_ = scom3_cam_pre[0] | scom3_cam_pre[1];
	scom3_cam_ |= scom3_cam_pre[2];
	scom3_cam_ |= scom3_cam_pre[3];
	scom3_cam_ |= scom3_cam_pre[4];
	scom3_cam_ |= scom3_cam_pre[5];
	
	scom3_cam_ |= scom3_;//照明の指令残し

	COM_VAL[14] = scom3_cam_;
	COM_VAL[15] = scom4_;
	//printf("SOCOM3 =%d\r\n", scom3_);



}
*/
if (DEV_NUM == 1 &&
	Right_Arm_Move == 0){
	COM_VAL[31] = DEV_Tmp[0];
	COM_VAL[32] = DEV_Tmp[1];
	COM_VAL[33] = DEV_Tmp[2];
	if (DEV_Tmp[3] == 128)COM_VAL[5] = DEV_Tmp[3];


}

if (COM_VAL[31]<2048) printf("Back \r\n");
if (COM_VAL[31]>2048) printf("Forward \r\n");
if (COM_VAL[33]>2048) printf("Right-Turn \r\n");
if (COM_VAL[33]<2048) printf("Left-Turn \r\n");
if (COM_VAL[5] == 128){
	printf("Body-");
	if (COM_VAL[32]>2048) printf("Right-Turn \r\n");
	if (COM_VAL[32]<2048) printf("Left-Turn \r\n");

}


printf("[8]%d   [10]%d   [34]%d   [35]%d\n"
	, COM_VAL[8], COM_VAL[10], COM_VAL[34], COM_VAL[35]);
printf("[9]%d   [11]%d   [36]%d   [37]%d\n"
	, COM_VAL[9], COM_VAL[11], COM_VAL[36], COM_VAL[37]);
printf("[30]%d   [31]%d   [32]%d   [33]%d\n"
	, COM_VAL[30], COM_VAL[31], COM_VAL[32], COM_VAL[33]);

	for (i = 0; i <= 37; i++){
		COM_SUM += COM_VAL[i];
	}

	//
	//以下for文にしないのはコマンド表が確定でないため
	//

	//------------以下５桁---------------------------------------------------------------------------------------------------------------------------------------------//
	S_COM1  = COM_int_to_str(5, COM_VAL[0]);
	S_COM2  = COM_int_to_str(5, COM_VAL[1]);
	S_CONT1 = COM_int_to_str(5, COM_VAL[2]);
	S_CONT2 = COM_int_to_str(5, COM_VAL[3]);
	S_DA1   = COM_int_to_str(5, COM_VAL[4]);
	S_DA2   = COM_int_to_str(5, COM_VAL[5]);
	S_DA3   = COM_int_to_str(5, COM_VAL[6]);
	S_DA4   = COM_int_to_str(5, COM_VAL[7]);
	S_DA5   = COM_int_to_str(5, COM_VAL[8]);
	S_DA6   = COM_int_to_str(5, COM_VAL[9]);
	S_DA7   = COM_int_to_str(5, COM_VAL[10]);
	S_DA8   = COM_int_to_str(5, COM_VAL[11]);
	S_DA9   = COM_int_to_str(5, COM_VAL[12]);
	S_DA10  = COM_int_to_str(5, COM_VAL[13]);
	S_COM3  = COM_int_to_str(5, COM_VAL[14]);
	S_COM4	= COM_int_to_str(5, COM_VAL[15]);
	//------------以下４桁---------------------------------------------------------------------------------------------------------------------------------------------//
	S_DA13  = COM_int_to_str(4, COM_VAL[16]);
	S_DA14  = COM_int_to_str(4, COM_VAL[17]);
	S_DA15  = COM_int_to_str(4, COM_VAL[18]);
	S_DA16  = COM_int_to_str(4, COM_VAL[19]);
	S_DA17  = COM_int_to_str(4, COM_VAL[20]);
	S_DA18  = COM_int_to_str(4, COM_VAL[21]);
	S_DA19  = COM_int_to_str(4, COM_VAL[22]);
	S_DA20  = COM_int_to_str(4, COM_VAL[23]);
	S_DA21  = COM_int_to_str(4, COM_VAL[24]);
	S_DA22  = COM_int_to_str(4, COM_VAL[25]);
	S_DA23  = COM_int_to_str(4, COM_VAL[26]);
	S_DA24  = COM_int_to_str(4, COM_VAL[27]);
	S_DA25  = COM_int_to_str(4, COM_VAL[28]);
	S_DA26  = COM_int_to_str(4, COM_VAL[29]);

	S_DA27  = COM_int_to_str(4, COM_VAL[30]);
	S_DA28  = COM_int_to_str(4, COM_VAL[31]);
	S_DA29  = COM_int_to_str(4, COM_VAL[32]);
	S_DA30  = COM_int_to_str(4, COM_VAL[33]);
	S_DA31  = COM_int_to_str(4, COM_VAL[34]);
	S_DA32  = COM_int_to_str(4, COM_VAL[35]);
	S_DA33  = COM_int_to_str(4, COM_VAL[36]);
	S_DA34  = COM_int_to_str(4, COM_VAL[37]);
	//------------以下５桁---------------------------------------------------------------------------------------------------------------------------------------------//
	
	COM_SUM = 0;
	for (i = 0; i <= 37; i++){
		COM_SUM +=	COM_VAL[i];
	}
	COM_VAL[38] = COM_SUM % 32768;
	CheckSum = COM_int_to_str(5, COM_VAL[38]);

	//
	//E1_COM 上記つなぎ合わせたもの　T54動作コマンド
	//
	E1_COM = S_COM1 + S_COM2 + S_CONT1 + S_CONT2 + S_DA1 + S_DA2 + S_DA3 + S_DA4 + S_DA5 + S_DA6 + S_DA7 + S_DA8 + S_DA9 + S_DA10 + S_COM3 + S_COM4
	+ S_DA13 + S_DA14 + S_DA15 + S_DA16 + S_DA17 + S_DA18 + S_DA19 + S_DA20 + S_DA21 + S_DA22 + S_DA23 + S_DA24 + S_DA25 + S_DA26 + S_DA27
	+ S_DA28 + S_DA29 + S_DA30 + S_DA31 + S_DA32 + S_DA33 + S_DA34 + CheckSum;

	printf("SOCOM5 =%d\r\n", COM_VAL[5]);
	printf("SOCOM7 =%d\r\n", COM_VAL[7]);
	printf("SOCOM3 =%d\r\n", COM_VAL[14]);
	printf("SOCOM4 =%d\r\n", COM_VAL[15]);

	m_Command.data = CORBA::string_dup(E1_COM.c_str());
	m_CommandOut.write();
  return RTC::RTC_OK;
}


std::string  COM_int_to_str(int data_num, int data){
	std::string str;

	std::ostringstream string45;
	string45 << std::setfill('0') << std::setw(data_num) << data;
	str = string45.str();
//	std::cout << str << std::endl;
	return str;

}
RTC::ReturnCode_t RTC_E1Motion_Manual::onAborting(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onError(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onReset(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onStateUpdate(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::onRateChanged(RTC::UniqueId ec_id)
{
  return RTC::RTC_OK;
}

RTC::ReturnCode_t RTC_E1Motion_Manual::Button_Rename()
{
	SQARE=button[0];
	CROSS=button[1];
	CIRCLE=button[2];
	TRIANGLE=button[3];
	L1=button[4];
	R1=button[5];
	L2=button[6];
	R2=button[7];
	SHARE=button[8];
	OPTION=button[9];
	L3=button[10];
	R3=button[11];
	PS=button[12];
	Touch=button[13];
	/**/
#ifdef _PRINT_DEBUG
	if(SQARE)
		std::cout<<"SQARE"<< std::endl;
	if(CROSS)
		std::cout<<"CROSS"<< std::endl;
	if(CIRCLE)
		std::cout<<"CIRCLE"<< std::endl;
	if(TRIANGLE)
		std::cout<<"TRIANGLE"<< std::endl;
	if(L1)
  	std::cout<<"L1"<< std::endl ;
	if(R1)
  	std::cout<<"R1"<< std::endl ;
	if(L2)
  	std::cout<<"L2" << std::endl ;
	if(R2)
  	std::cout<<"R2" << std::endl ;
	if(SHARE)
  	std::cout<<"SHARE" << std::endl ;
	if(OPTION)
  	std::cout<<"OPTION" << std::endl ;
	if(L3)
  	std::cout<<"L3" << std::endl ;
	if(R3)
  	std::cout<<"R3" << std::endl ;
	if(PS)
  	std::cout<< "PS" << std::endl ;
	if(Touch)
  	std::cout<<"Touch" << std::endl ;
#endif
  return RTC::RTC_OK;
}


RTC::ReturnCode_t RTC_E1Motion_Manual::Analog_Rename()
{

	if(m_Analog.data[0]==-1){
		HAT_UP=1;
		HAT_DOWN=0;
	}else if(m_Analog.data[0]==1){
	 	HAT_UP=0;
	 	HAT_DOWN=1;
	}else{
		HAT_UP=0;
		HAT_DOWN=0;
	}
	if(m_Analog.data[1]==-1){
		HAT_RIGHT=0;
		HAT_LEFT=1;
	}else if(m_Analog.data[1]==1){
	 	HAT_RIGHT=1;
	 	HAT_LEFT=0;
	}else{
		HAT_RIGHT=0;
		HAT_LEFT=0;
	}

	LEFT_X=m_Analog.data[2];
	LEFT_Y=m_Analog.data[3];
	RIGHT_X=m_Analog.data[4];
	RIGHT_Y=m_Analog.data[5];
	L2_A=m_Analog.data[6];
	R2_A=m_Analog.data[7];
	
#ifdef _PRINT_DEBUG
	
	
	if(HAT_UP)

		std::cout<< "↑ " << std::endl ;
	if(HAT_DOWN)
  		std::cout<<"↓ " << std::endl ;
	if(HAT_UP)
	std::cout<<"↑ "<<std::endl;
	if(HAT_DOWN)
  	std::cout<<"↓ " << std::endl ;
	if(HAT_RIGHT)
  	std::cout << "→ " << std::endl ;
	if(HAT_LEFT)
  	std::cout<< "← " << std::endl ;
	//L_X
	std::cout<< LEFT_X << std::endl ;
	//L_Y
  	std::cout <<LEFT_Y << std::endl ;
	//R_X
  	std::cout<<RIGHT_X << std::endl ;
	//R_Y
  	std::cout<< RIGHT_Y << std::endl ;
	//L2
  	std::cout<<L2_A << std::endl ;
	//R2
  	std::cout<< R2_A << std::endl ;
	
#endif
  return RTC::RTC_OK;
}


extern "C"
{
 
  void RTC_E1Motion_ManualInit(RTC::Manager* manager)
  {
    coil::Properties profile(rtc_e1motion_manual_spec);
    manager->registerFactory(profile,
                             RTC::Create<RTC_E1Motion_Manual>,
                             RTC::Delete<RTC_E1Motion_Manual>);
  }
  
};


